#ifndef SQLITE_SQLDATABASE_H
#define SQLITE_SQLDATABASE_H

struct sqlite3;

namespace sql3
{
class Database
{
	friend class Query;
public:
	static const int OPEN_READONLY;
	static const int OPEN_READWRITE;
	static const int OPEN_CREATE;
	static const int OPEN_DEFAULT;

	Database();
	~Database();

	bool Connect(const char* filename, int flags = OPEN_DEFAULT);
	bool Disconnect();

	bool Execute(const char* cmd);
	bool Executef(const char* cmd, ...);

	const char* GetLastErrorMessage() const;

private:
	sqlite3*	m_db;
};

}

#endif // 
