#include <windows.h>
#include <cstdio>
#include "sqlite/CRC32.h"
#include "sqlite/SQLDatabase.h"
#include "sqlite/SQLQuery.h"

typedef struct tagDEBUGHELPER
{
	DWORD dwVersion;
	BOOL (WINAPI *ReadDebuggeeMemory)( struct tagDEBUGHELPER *pThis, DWORD dwAddr, DWORD nWant, VOID* pWhere, DWORD *nGot );
	// from here only when dwVersion >= 0x20000
	DWORDLONG (WINAPI *GetRealAddress)( struct tagDEBUGHELPER *pThis );
	BOOL (WINAPI *ReadDebuggeeMemoryEx)( struct tagDEBUGHELPER *pThis, DWORDLONG qwAddr, DWORD nWant, VOID* pWhere, DWORD *nGot );
	int (WINAPI *GetProcessorType)( struct tagDEBUGHELPER *pThis );
} DEBUGHELPER;

typedef HRESULT (WINAPI *CUSTOMVIEWER)( DWORD dwAddress, DEBUGHELPER *pHelper, int nBase, BOOL bUniStrings, char *pResult, size_t max, DWORD reserved );


#define ADDIN_API __declspec(dllexport)

extern "C" ADDIN_API HRESULT WINAPI AddIn_CRC32(
	DWORD dwAddress, DEBUGHELPER *pHelper, int nBase, BOOL bUniStrings, char *pResult, size_t max, DWORD reserved);

ADDIN_API HRESULT WINAPI AddIn_CRC32(
	DWORD /*dwAddress*/, DEBUGHELPER *pHelper, int /*nBase*/, BOOL /*bUniStrings*/, char *pResult, size_t max, DWORD)
{
	static sql3::Database	s_crcDatabase;
	static bool			s_databaseOpened(false);

	if (!s_databaseOpened)
	{
		if (!s_crcDatabase.Connect("c:\\crc32.db"))
		{
			sprintf_s(pResult, max, "Cannot open DB");
			return S_OK;
		}
		s_databaseOpened = true;
	}

	rde::CRC32 crc;
	DWORD bytesRead(0);
	const DWORD bytesToRead = sizeof(crc);
	if (pHelper->ReadDebuggeeMemoryEx(pHelper, pHelper->GetRealAddress(pHelper), 
		bytesToRead, &crc, &bytesRead) != S_OK || bytesRead != bytesToRead)
	{
		return E_FAIL;
	}

	sql3::Query q(s_crcDatabase);
	q.Executef("SELECT * from crcTab WHERE crc=%u", crc.GetValue());
	if (q.NextRow() <= 0)
	{
		sprintf_s(pResult, max, "Txt=<not found>, CRC=0x%X", crc.GetValue());
		return S_OK;
	}
	sprintf_s(pResult, max, "Txt=%s, CRC=0x%X", q.GetString(1), crc.GetValue());
	//sprintf_s(pResult, max, "CRC=%d", crc.GetValue());

	return S_OK;
}
